/*
 * Copyright (C) 1996-1998 by the Board of Trustees
 *    of Leland Stanford Junior University.
 * 
 * This file is part of the SimOS distribution. 
 * See LICENSE file for terms of the license. 
 *
 */

/*
 * rpc.c -- program to run on top of SIMOS to test the hive rpc subsystem
 * Usage: rpc is_server iterations
 *
 */

#define HIVE
#include "simosapps.h"
#include "stdio.h"
#include "sys/sysmp.h"

int main(int argc, char** argv)
{
   int is_server;
   int niter;
   int err;
   if (argc < 3) {
      printf("usage: rpc is_server niter\n");
      return 1;
   }
   
   is_server = atoi(argv[1]);
   niter = atoi(argv[2]);

   err = sysmp(MP_HIVE, MPHI_RPCTEST, is_server, niter);
   if (err) {
      perror("starting test");
   }
   return 0;
}
