/*
 * Copyright (C) 1996-1998 by the Board of Trustees
 *    of Leland Stanford Junior University.
 * 
 * This file is part of the SimOS distribution. 
 * See LICENSE file for terms of the license. 
 *
 */

/*
 * rpc_server.c -- process that becomes a rpc server process
 *
 */

#define HIVE
#include "simosapps.h"
#include "stdio.h"
#include "sys/sysmp.h"
#include "unistd.h"

int main(int argc, char** argv)
{
   int err;
   
   if (_daemonize(0, -1, -1, 2) < 0) {
      perror("rpc_server: becoming daemon\n");
      return 1;
   }
   err = sysmp(MP_HIVE, MPHI_RPCSERVER);
   if (err) {
      perror("rpc_server: starting server");
   }
   /* notreached (MPHI_RPCSERVER never returns) */
   return 1;
}
