#
# Copyright (C) 1998 by the Board of Trustees
#    of Leland Stanford Junior University.
# Copyright (C) 1998 Digital Equipment Corporation
#
# This file is part of the SimOS distribution.
# See LICENSE file for terms of the license.
#

#
# Copyright (C) 1996-1998 by the Board of Trustees
#    of Leland Stanford Junior University.
# 
# This file is part of the SimOS distribution. 
# See LICENSE file for terms of the license. 
#


##
## return a physical address or 0 if failure
##
## assumes kernel has been defined
##

#hardcoded constants that depend on the pa/va size and the kernel 
set ADDRESS_MASK 0x000007ffffffffff
set KSEG_MASK 0x000001ffffffffff
set PGSHIFT 13
set PGMASK 0x01fff
set PFNSHIFT 32
set SELFMAP 0xfffffffc00000000
set OTHERMAP 0xfffffffa00000000
set SEGSHIFT 41

proc TclTranslateVirtual {cpuNum vAddr} {
    global ADDRESS_MASK KSEG_MASK PGSHIFT SELFMAP PGMASK PFNSHIFT SEGSHIFT OTHERMAP
    global IPR

#     console "**********************************TTV called for VA $vAddr\n"
    
    set seg [expr ($vAddr >> $SEGSHIFT) & 0x3]
    # kseg address slipped through
    if {$seg == 0x2} {
        set paddr [expr $vAddr & $KSEG_MASK]
#        console "**********************************TTV SUCCESS: PA is $paddr, VA is $vAddr\n"
        return $paddr
    }
    
    set va [expr $vAddr & $ADDRESS_MASK]
    set va [expr $va >> $PGSHIFT]
    set pteaddr [expr $SELFMAP + (8 * $va)]
#     console "**********************************TTV ptr address for VA $vAddr is [hex $pteaddr] seg $seg\n"
    if {$pteaddr == $vAddr} {
        return 0
    }
    set pte [symbol read "vmunix::((long *)$SELFMAP)<$va>"]
#    console "**********************************TTV VA is $vAddr, VPFN is $va, PTE is [hex $pte]\n"
    if {$pte & 0x01} {
        set paddr [expr ($pte >> $PFNSHIFT) << $PGSHIFT]
        set paddr [expr $paddr | ($vAddr & $PGMASK)]
#        console "**********************************TTV SUCCESS: PA is $paddr, VA is $vAddr\n"
        return $paddr
    } else {
        return 0
    }
}







