#
# Copyright (C) 1998 by the Board of Trustees
#    of Leland Stanford Junior University.
# Copyright (C) 1998 Digital Equipment Corporation
#
# This file is part of the SimOS distribution.
# See LICENSE file for terms of the license.
#

 

####
#### configuration files for setup at WRL
#### This information is not Digital confidential, it
#### is just useless if you are not working from WRL
#### --Ed

####
#### This file to be sourced after defaults.tcl
#### diskFileName($disk) must be defined for 
#### disks 3 and up.

FileSourced "wrl.tcl"

if [info exists env(SIMOS_DIR)] {
    set wrlDirectory $env(SIMOS_DIR)
} else {
    set wrlDirectory /wrl/proj/simos/support-files
}

console "wrlDirectory=$wrlDirectory\n"

set PARAM(ALPHA.Files.PALCode)  "$wrlDirectory/runtime-files/osfpal"
set PARAM(ALPHA.Files.Console)  "$wrlDirectory/runtime-files/console.ver2"
set PARAM(ALPHA.Files.Kernel)   "$wrlDirectory/runtime-files/vmunix"

set bdoorExecutable "$wrlDirectory/runtime-files/bdoor-osf-static"


set diskFileName(0,1) "$wrlDirectory/disks/root-disk"

proc DiskFileName { machine node ctrl disk } {
    global wrlDirectory diskFileName
    if [catch {
	if {($machine != 0) || ($node!=0) || ($ctrl >= 4) } {
	    console "apps/tcl/osf/wrl.tcl::DiskFileName machine=$machine node=$node ctrl=$ctrl wierd  \n"
	    exit
	}
	if [info exists diskFileName($disk)] {
	    set f $diskFileName($disk)
        } elseif [info exists diskFileName($ctrl,$disk)] {
            set f $diskFileName($ctrl,$disk)
	} else {
            ###
            ### not that NOTDEF() is a keyword for the rmtaccess server
            ###
	    set f "NOTDEF($disk)"
	}
    } msg ]  {
	console "Error in DiskFileName $msg \n"
	exit
    }
    console "DiskFileName $machine $node $ctrl $disk :: $f ::\n"
    return $f
}




proc WrlDiskFileName { disk } {
    console "WrlDiskFileName called for disk $disk \n"
    console "This function is defined in apps/tcl/osf/wrl.tcl\n"
    console "Must be overriden in init.simos after sourcing wrl.tcl\n"
    exit
}


		   




