/*
 * Copyright (C) 1996-1998 by the Board of Trustees
 *    of Leland Stanford Junior University.
 * 
 * This file is part of the SimOS distribution. 
 * See LICENSE file for terms of the license. 
 *
 */

/*****************************************************************
 * arch_specifics.h -- a toplevel include file that keeps 
 * ifdefs out of the common code
 *****************************************************************/
#ifndef _ARCH_SPECIFICS_H
#define _ARCH_SPECIFICS_H

#if !defined(SIM_ALPHA) && !defined(SIM_MIPS32) && !defined(SIM_MIPS64) && !defined(SIM_X86)
<error - must define one ISA>
#endif

#if defined(SIM_ALPHA)
# include "../../cpus-alpha/alpha-shared/addr_layout.h"
# include "../../cpus-alpha/alpha-shared/alpha_arch.h"
# include "../../cpus-alpha/alpha-shared/alpha_gdb.h"
#define PAGE_SIZE               8192
#define NBPP                    PAGE_SIZE
#endif

#if defined(SIM_MIPS32)
# include "../../cpus/shared/addr_layout.h"
# include "../../cpus/shared/mips_arch.h"
# include "../../cpus/shared/mips_gdb.h"
# include "../../cpus/simos/simmisc.h"
#define PAGE_SIZE               4096
#ifndef NBPP
#define NBPP                    PAGE_SIZE /* number of bytes per page */
#endif
#endif


#if defined(SIM_MIPS64)
# include "../../cpus/shared/addr_layout.h"
# include "../../cpus/shared/mips_arch.h"
# include "../../cpus/shared/mips_gdb.h"
# include "../../cpus/simos/simmisc.h"
#define PAGE_SIZE               4096
#ifndef NBPP
#define NBPP                    PAGE_SIZE /* number of bytes per page */
#endif
#endif

#if defined(SIM_X86)
# include "../../cpus-x86/shared/addr_layout.h"
# include "../../cpus-x86/shared/x86_arch.h"
# include "../../cpus-x86/shared/x86_gdb.h"
# define PAGE_SIZE               4096
# ifndef NBPP
#  define NBPP                   PAGE_SIZE /* number of bytes per page */
# endif
#endif /* def SIM_X86 */

#endif
