/*
 * Copyright (C) 1996-1998 by the Board of Trustees
 *    of Leland Stanford Junior University.
 * 
 * This file is part of the SimOS distribution. 
 * See LICENSE file for terms of the license. 
 *
 */

/*
 * sim.h - Common included file used for simulated machine.
 *
 */

#ifndef SIM_H
#define SIM_H

#define _BSD_SIGNALS

#include <sys/time.h>
#include <signal.h>
#ifndef __alpha
#include <sys/types.h>
#endif
#include <sys/stat.h>
#include <fcntl.h>
/*
 * ANSI C prototype support and backward compat macros. 
 */

#if defined(__STDC__) || defined(_LANGUAGE_C_PLUS_PLUS)
#define _ARGS_(x)       x
#else
#define _ARGS_(x)       ()
#endif

#ifndef SIMBASEADDR
#define SIMBASEADDR 0x78000000
#endif

/*
 * Error routines. 
 */

extern void Sim_Error _ARGS_((char *msg));
extern void Sim_Warning _ARGS_((char *fmt, ...));

#define SIMASSERT(x)  {if (!(x)) {Sim_Warning("%s:%d: assertion failed: %s", \
					     __FILE__, __LINE__, # x);      \
                                  Sim_Error("ASSFAIL");}}

#endif /* SIM_H */
