/*
 * Copyright (C) 1996-1998 by the Board of Trustees
 *    of Leland Stanford Junior University.
 * 
 * This file is part of the SimOS distribution. 
 * See LICENSE file for terms of the license. 
 *
 */

/*****************************************************************
 * instr_util.h
 *
 * Interface into the instruction utilization package. Here we 
 * measure the amount of each instruction cache line that is 
 * actually accessed.
 *
 * $Author: verghese $
 * $Date: 1999/09/27 22:07:43 $
 ****************************************************************/

#ifndef _INSTR_UTIL_H
#define _INSTR_UTIL_H

extern void InstrUtilEarlyInit(void);
extern void InstrUtilLateInit(void);

extern void InstrUtilNewLine(int cpuNum, VA vAddr, PA pAddr, int setEntry);
extern void InstrUtilReplaceLine(int cpuNum, PA pAddr, int setEntry);

#endif /* _INSTR_UTIL_H */
