/*
 * Copyright (C) 1998 by the Board of Trustees
 *    of Leland Stanford Junior University.
 * Copyright (C) 1998 Digital Equipment Corporation
 *
 * This file is part of the SimOS distribution.
 * See LICENSE file for terms of the license.
 *
 */



#ifndef ALPHA_PARAMS_H
#define ALPHA_PARAMS_H

void AlphaCommitAnnExec();

/*
 * AlphaParams
 * Data structure passed to the SRM and ARC console at startup time. 
 * !!! Modifications require a recompilation of both consoles
 */


struct AlphaConsoleParams {
   int bootNT;       
   char *PALcodeFileName;
   char *consoleFileName;
   char *kernelFileName;
   char *NT_FirmwareFileName;
   char *NT_OSLoaderFileName;
}; 

extern struct AlphaConsoleParams alphaConsoleParams;


/*
 * Debugging paramters
 */

struct AlphaDebugParams { 
   int debugTraps;
   int debugInterrupts;
   int debugVATranslation;
   int debugTBInsert;
};

extern struct AlphaDebugParams  alphaDebugParams;


void AlphaCommitAnnExec();

#endif
