/*
 * cpu_interface.h -- interface to Sam debugging support
 */

extern void    SamCPUVectorInit(void);
extern SimTime SamCycleCount(int);
extern SimTime SamInstructionCount(int);
extern int     SamDebug(int cpunum, int is_break_instruction);
extern Result  SamPutReg(int cpunum, int regnum, Reg val);
extern Result  SamPutMem(int cpunum, VA vAddr, uint nbytes, char *buf);

extern void    SamUnstall(int cpuNum); 
extern void    SamTakeBusError(int cpuNum, bool isIRef, VA vAddr);

extern void    SamTurnOnCaches(void);
extern void    SamTurnOffCaches(void);
extern bool    SamCachesAreOn(void);

#define SAM_NOBREAK      (-2)
#define SAM_BREAKANYCPU  (-1)

extern int sam_debug_mode;
extern int sam_break_nexti;
extern int sam_sigusr;
extern int SamArithTrap;

extern int SamSkipCaches;
