/*
 * funcunit.h -- the Sam functional unit structure and macros
 */

#ifndef SAM_FUNCUNIT_H
#define SAM_FUNCUNIT_H

#include "iwin.h"
#include "list.h"
#include "simtypes.h"

/*
 * Function that returns whether the instruction can execute in the
 * specified functional unit.  Out params latency and repeatRate record
 * the number of cycles to complete the instruction and the number of 
 * cycles before the unit can begin processing another instruction.
 */

typedef bool (SamFuncUnitInfo)(SamIwinEntry *ip, 
                               int *latency, int *repeatRate);

/* Functional unit state */

typedef struct {
   char * typeString;
   SimTime numExecuted;
   SimTime availTime;           // Cycle when unit can accept a new instruction
   SamFuncUnitInfo *CanExecute; // Report which instructions can be executed
} SamFuncUnit;

#endif /* SAM_FUNCUNIT_H */
