/*
 * instruction.h -- Decode/execute information for instructions
 */

/* Instruction decode routines */

typedef void (SamDecodeFunc)(SamState *, SamIwinEntry *);

extern SamDecodeFunc SamDecodePAL;
extern SamDecodeFunc SamDecodeLoadAddress;
extern SamDecodeFunc SamDecodeMemLoad;
extern SamDecodeFunc SamDecodeMemStore;
extern SamDecodeFunc SamDecodeBranch;
extern SamDecodeFunc SamDecodeJump;
extern SamDecodeFunc SamDecodeOperate;
extern SamDecodeFunc SamDecodeFloating;
extern SamDecodeFunc SamDecodeMisc;
extern SamDecodeFunc SamDecodeIllegal;

/* Instruction execution routines */

typedef void (SamExecuteFunc)(SamState *, SamIwinEntry *);

extern SamExecuteFunc SamExecutePAL;
extern SamExecuteFunc SamExecuteLoadAddress;
extern SamExecuteFunc SamExecuteMemLoad;
extern SamExecuteFunc SamExecuteMemStore;
extern SamExecuteFunc SamExecuteBranch;
extern SamExecuteFunc SamExecuteJump;
extern SamExecuteFunc SamExecuteOperate;
extern SamExecuteFunc SamExecuteFloating;
extern SamExecuteFunc SamExecuteMisc;
extern SamExecuteFunc SamExecuteIllegal;

typedef struct {
   char *name;
   SamDecodeFunc *decode;
   SamExecuteFunc *execute;
} SamInstructionInfo;

extern SamInstructionInfo samInstructionTable[64];
