/*
 * Copyright (C) 1998 by the Board of Trustees
 *    of Leland Stanford Junior University.
 * Copyright (C) 1998 Digital Equipment Corporation
 *
 * This file is part of the SimOS distribution.
 * See LICENSE file for terms of the license.
 *
 */

#ifndef ALPHA_ACCESS_H
#define ALPHA_ACCESS_H

#define ALPHA_ACCESS_VERSION (1291+2) /* CH++ */

typedef struct AlphaAccess {

   int last_offset; /* must be first field */
   int version;

   /*---------------------------
    * Machine configuration
    *---------------------------*/
   int numCPUs; 
   long mem_size;
   long cpuClock; /*MHz*/
   int intrClockFrequency; /* Hz */

   /*---------------------------
    * Boot parameters
    *---------------------------*/
   /* Loaded kernel */
   long kernStart;
   long kernEnd;
   long entryPoint;

   /*---------------------------
    * Console IO stuff
    *---------------------------*/
   /* console disk stuff */
   long diskUnit;    
   long diskCount;
   long diskPAddr;
   long diskBlock;
   long diskOperation;
   
   /* console simple access stuff */
   long outputChar;
   long inputChar;

   /*---------------------------
    * OSF/1 Specific
    *---------------------------*/
   /* MP boot */
   long bootStrapImpure;
   int bootStrapCPU;

   /*---------------------------
    * NT Specific
    *---------------------------*/
    char envName[64];
    char envValue[128];
    long getEnv;       /* Write to get the variable in envname */
    long setEnv;       /* Write to set the variable in envname */

} AlphaAccess;

extern AlphaAccess *alphaAccessArray;

#endif

