/*
 * Copyright (C) 1998 by the Board of Trustees
 *    of Leland Stanford Junior University.
 * Copyright (C) 1998 Digital Equipment Corporation
 *
 * This file is part of the SimOS distribution.
 * See LICENSE file for terms of the license.
 *
 */

/* --------------------------------------------------- */
/* | Copyright (c) 1986 MIPS Computer Systems, Inc.  | */
/* | All Rights Reserved.                            | */
/* --------------------------------------------------- */


/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

/*
 * 	This file is a collection of various xcoff related header
 *	for alpha, with modifications to structures to work with
 *	a 32-bit C compiler.
 *
 * 	04-Oct-1990, Ken Lesniak
 */

struct new_filehdr {
	unsigned short	f_magic;	/* magic number */
	unsigned short	f_nscns;	/* number of sections */
	int		f_timdat;	/* time & date stamp */
	int		f_symptr;	/* file pointer to symbolic header */
	int		f_symptr_hi;
	int		f_nsyms;	/* sizeof(symbolic hdr) */
	unsigned short	f_opthdr;	/* sizeof(optional hdr) */
	unsigned short	f_flags;	/* flags */
};
#define ALPHAMAGIC 0603

#define	NEW_FILHDR	struct new_filehdr
#define	NEW_FILHSZ	sizeof(NEW_FILHDR)

struct new_aouthdr {
	short	magic;		/* see above				*/
	short	vstamp;		/* version stamp			*/
	int	pad0;
	int	tsize;		/* text size in bytes, padded to DW bdry*/
	int	tsize_hi;
	int	dsize;		/* initialized data "  "		*/
	int	dsize_hi;
	int	bsize;		/* uninitialized data "   "		*/
	int	bsize_hi;
	int	entry;		/* entry pt.				*/
	int	entry_hi;
	int	text_start;	/* base of text used for this file	*/
	int	text_start_hi;
	int	data_start;	/* base of data used for this file	*/
	int	data_start_hi;
	int	bss_start;	/* base of bss used for this file	*/
	int	bss_start_hi;
	int	gprmask;	/* general purpose register mask	*/
	int	fprmask;
	int	gp_value;	/* the gp value used for this object    */
	int	gp_value_hi;
};

#define NEW_AOUTHDR struct new_aouthdr
#define NEW_AOUTHSZ sizeof(NEW_AOUTHDR)

struct new_scnhdr {
	char		s_name[8];	/* section name */
	int		s_paddr;	/* physical address, aliased s_nlib */
	int		s_paddr_hi;
	int		s_vaddr;	/* virtual address */
	int		s_vaddr_hi;
	int		s_size;		/* section size */
	int		s_size_hi;
	int		s_scnptr;	/* file ptr to raw data for section */
	int		s_scnptr_hi;
	int		s_relptr;	/* file ptr to relocation */
	int		s_relptr_hi;
	int		s_lnnoptr;	/* file ptr to gp histogram */
	int		s_lnnoptr_hi;
	unsigned short	s_nreloc;	/* number of relocation entries */
	unsigned short	s_nlnno;	/* number of gp histogram entries */
	int		s_flags;	/* flags */
};

#define NEW_SCNROUND	16
#define	NEW_SCNHDR	struct new_scnhdr
#define	NEW_SCNHSZ	sizeof(NEW_SCNHDR)

#define NEW_C_TXTOFF(f,a) \
 ((a).magic == ZMAGIC || (a).magic == LIBMAGIC ? 0 : \
  ((a).vstamp < 23 ? \
   ((NEW_FILHSZ + NEW_AOUTHSZ + (f).f_nscns * NEW_SCNHSZ + 7) & 0xfffffff8) : \
   ((NEW_FILHSZ + NEW_AOUTHSZ + (f).f_nscns * NEW_SCNHSZ + NEW_SCNROUND-1) & ~(NEW_SCNROUND-1)) ) )
