/*
This file is from the simos simulation tree

simulation/cpus-alpha/simos/simos_scsi.h

It is included here for the kernel build
Not the best solution
*/

#ifndef _SIMOS_SCSI_H
#define _SIMOS_SCSI_H

#define SIMOS_SCSI_ADDR       0xfffffcc500000000
#define SIMOS_SCSI_ADDR_32    0xffffffffa5000000
#define SIMOS_SCSI_MAXDMA_LEN 128
#define SIMOS_SCSI_MAXCTLR    16
#define SIMOS_SCSI_MAXTARG    16
#define SIMOS_SCSI_MAXLUN     16

#define SIMOS_SCSI_REGS     ((struct SimOS_SCSI *)SIMOS_SCSI_ADDR)
#define SIMOS_SCSI_REGS_32  ((struct SimOS_SCSI *)SIMOS_SCSI_ADDR_32)

typedef unsigned long SCSIReg;


typedef struct SimOS_SCSI {
   SCSIReg startIO;   /* write-only */
   SCSIReg done[SIMOS_SCSI_MAXTARG];  /* read-write (write=ack) */

   SCSIReg target;                     /* data fields */
   SCSIReg lun;
   SCSIReg cmd[12];
   SCSIReg length;
   SCSIReg sgLen;
   struct {
      SCSIReg pAddr;
      SCSIReg len;
   } sgMap[SIMOS_SCSI_MAXDMA_LEN];
   
   
} SimOS_SCSI;

#ifndef _KERNEL

extern int SimOS_SCSI_access(int cpuNum, VA vA, int type, Reg *buff);

extern void SimOS_SCSI_intr(int node,int ctrl, int unit, int on);

extern int SimOS_SCSI_Pending(int cpuNum);

#endif /* !_KERNEL */

#endif

