/*
 * Copyright (C) 1998 by the Board of Trustees
 *    of Leland Stanford Junior University.
 * Copyright (C) 1998 Digital Equipment Corporation
 *
 * This file is part of the SimOS distribution.
 * See LICENSE file for terms of the license.
 *
 */

#ifndef _AINT_H_
#define _AINT_H_

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include "event.h"
#include "task.h"
#include "export.h"

/* This is needed by the Hemingway Simulator */
extern unsigned long data_end;	/* end of all private memory */

#define SIM_USER_ACQUIRE 1
#define SIM_USER_RELEASE 2

/*
 * stubs
 */

#define EVENT1(x)
#define EVENT2(x,y)
#define EVENT3(x,y,z)

#define event_timed_block EVENT3
#define event_write EVENT2
#define event_load_locked EVENT2
#define event_read EVENT2
#define event_write EVENT2
#define event_store_conditional EVENT2
#define event_sim_user EVENT2
#define event_terminate EVENT1
#define event_block EVENT2
#define event_yield EVENT2
#define event_unblock EVENT2
#define event_unblock_list EVENT2
#define event_block EVENT2






#endif /* _AINT_H_ */
