/*
 * Copyright (C) 1998 by the Board of Trustees
 *    of Leland Stanford Junior University.
 * Copyright (C) 1998 Digital Equipment Corporation
 *
 * This file is part of the SimOS distribution.
 * See LICENSE file for terms of the license.
 *
 */

#ifndef _SIM_H_
#define _SIM_H_

#include "task.h"

extern void sim_block (task_ptr);
		/* Prototype include a typedef name.
		   It should be moved after the typedef declaration */
extern void sim_checkpoint (task_ptr);
		/* Prototype include a typedef name.
		   It should be moved after the typedef declaration */
extern void sim_done (double, double);
extern void sim_deadlock ();
extern int sim_exit (task_ptr);
		/* Prototype include a typedef name.
		   It should be moved after the typedef declaration */
extern void sim_fork (task_ptr);
		/* Prototype include a typedef name.
		   It should be moved after the typedef declaration */
extern int sim_init (int, char *[]);
extern int sim_load_locked (task_ptr);
		/* Prototype include a typedef name.
		   It should be moved after the typedef declaration */
extern int sim_memory_barrier (task_ptr);
		/* Prototype include a typedef name.
		   It should be moved after the typedef declaration */
extern int sim_read (task_ptr);
		/* Prototype include a typedef name.
		   It should be moved after the typedef declaration */
extern int sim_store_conditional (task_ptr);
		/* Prototype include a typedef name.
		   It should be moved after the typedef declaration */
extern int sim_terminate (task_ptr);
extern void sim_unblock (task_ptr);
extern int sim_write (task_ptr);
extern int sim_user (task_ptr);
extern int sim_inst (task_ptr);
extern void sim_usage (int, char *[]);

extern int sim_null (task_ptr);	/* Simply returns T_ADVANCE */

#endif /* _SIM_H_ */
