#ifndef X86_GDB_H
#define X86_GDB_H

#if defined(SIM_ALPHA) || defined(SIM_MIPS32) || defined(SIM_MIPS64)
<--- should not be here --->
#endif

/* For getreg and putreg, you need a mapping from register number
 * to x86 register.
 */

#define GDB_NUM_REGS  16 /* Current GDB only knows about the first 16 regs */

#define REGISTER_NAMES { \
  "eax", "ecx",  "edx",  "ebx",    "esp", \
  "ebp", "esi",  "edi",  "eip", "eflags",  \
  "cs",  "ss",   "ds",   "es",     "fs", \
  "gs",  "ldtr",  "tr", \
  "cr0", "cr1", "cr2",  "cr3",  "cr4" \
  "gdtr_base", "gdtr_limit",  \
  "idtr_base", "idtr_limit",  \
  "cs_desc_lo",  "cs_desc_hi",   "ss_desc_lo",  "ss_desc_hi", \
  "ds_desc_lo",  "ds_desc_hi",   "es_desc_lo",  "es_desc_hi", \
  "fs_desc_lo",  "fs_desc_hi",   "gs_desc_lo",  "gs_desc_hi", \
  "ldtr_desc_lo",  "ldtr_desc_hi",   "tr_desc_lo",  "tr_desc_hi" \
  "tsc_lo", "tsc_hi", \
   "dr0", "dr1", "dr2", "dr3", "dr4", "dr5", "dr6", "dr7" \
}

#define EAX_REGNUM 0
#define ECX_REGNUM 1
#define EDX_REGNUM 2
#define EBX_REGNUM 3
#define ESP_REGNUM 4
#define EBP_REGNUM 5
#define ESI_REGNUM 6
#define EDI_REGNUM 7
#define EIP_REGNUM 8
#define EFLAGS_REGNUM 9
#define CS_REGNUM 10
#define SS_REGNUM 11
#define DS_REGNUM 12
#define ES_REGNUM 13
#define FS_REGNUM 14
#define GS_REGNUM 15
#define LDTR_REGNUM 16
#define TR_REGNUM 17
#define CR0_REGNUM 18
#define CR1_REGNUM 19
#define CR2_REGNUM 20
#define CR3_REGNUM 21
#define CR4_REGNUM 22
#define GDTR_BASE_REGNUM 23
#define GDTR_LIMIT_REGNUM 24
#define IDTR_BASE_REGNUM 25
#define IDTR_LIMIT_REGNUM 26
#define CS_DESC_LO_REGNUM 27
#define CS_DESC_HI_REGNUM 28
#define SS_DESC_LO_REGNUM 29
#define SS_DESC_HI_REGNUM 30
#define DS_DESC_LO_REGNUM 31
#define DS_DESC_HI_REGNUM 32
#define ES_DESC_LO_REGNUM 33
#define ES_DESC_HI_REGNUM 34
#define FS_DESC_LO_REGNUM 35
#define FS_DESC_HI_REGNUM 36
#define GS_DESC_LO_REGNUM 37
#define GS_DESC_HI_REGNUM 38
#define LDTR_DESC_LO_REGNUM 39
#define LDTR_DESC_HI_REGNUM 40
#define TR_DESC_LO_REGNUM 41
#define TR_DESC_HI_REGNUM 42
#define TSC_LO_REGNUM  43
#define TSC_HI_REGNUM  44
#define DR0_REGNUM  45
#define DR1_REGNUM  46
#define DR2_REGNUM  47
#define DR3_REGNUM  48
#define DR4_REGNUM  49
#define DR5_REGNUM  50
#define DR6_REGNUM  51
#define DR7_REGNUM  52



#endif /* ndef X86_GDB_H */
