/************************************************************
 *
 *  intr.h 
 *
 ************************************************************/

#ifndef _INTR_H_
#define _INTR_H_

#define NO_INTR_PENDING  (-1)  /* Return by Intr_Check when no intr is pending */

struct IODevices;

typedef struct PIC {
   uint8        ICW1;
   uint8        ICW2;
   uint8        ICW3;
   uint8        ICW4;
   uint8        OCW;
   uint8        IRR;
   uint8        IMR;
   uint8        ISR;
   int          INT_line;
   int          nextInitWord;
   struct PIC   *master;        /* master, slave_chain and cascase_IRQ           */
   struct PIC   *slave_chain;   /* are properties of the wiring between PICs     */
   int          cascade_IRQ;    /* not really of the PICs themselves             */
} PIC;

void Intr_Init(struct IODevices *iod);
void Intr_Raise(struct IODevices *iod, int IRQ_line);
int Intr_Check(struct IODevices *iod);

#endif
