/************************************************************
 *
 *  iodevs.h 
 *
 ************************************************************/

#ifndef _IODEVS_H_
#define _IODEVS_H_

#include "vserial.h"
#include "vconsole.h"
#include "vscsi.h"
#include "intr.h"

#define NUM_COM_PORTS   4
#define NUM_PICS        2

struct IOS_Bucket;

typedef struct IODevices {
   struct IOS_Bucket    *IOS_Hash;
   PIC                  pic[NUM_PICS];
   SerialPort           com[NUM_COM_PORTS];
   VConsole             console;
   VScsi_Info           scsi0_drive[8];
   int                  scsi0_IRQ;
} IODevices;


extern void InitIODevices(void);
extern IODevices *GetIODevices(int cpuNum);
extern void InstallPoller(void);

#endif
