/************************************************************
 *
 *  iospace.h
 *
 ************************************************************/

#ifndef _IOSPACE_H_
#define _IOSPACE_H_

#include "iodevs.h"

#define PORT_IN    0
#define PORT_OUT   1

#define EXC_NONE       0
#define EXC_BUS_ERROR  1
#define EXC_SEGV       2
#define EXC_PF         3


typedef int (*IOSpace_Func)(IODevices *iod, uint16 port, int size, int inout, char *byte,
                            void *clientData);

void IOSpace_Init(IODevices *iod);
void IOSpace_Register(IODevices *iod, uint16 addr, IOSpace_Func f, void *clientData);
void IOSpace_Unregister(IODevices *iod, uint16 addr, IOSpace_Func f);
int IOSpace_InOut(IODevices *iod, uint16 addr, int size, int inout, void *byte);

#endif
