/************************************************************
 *
 *  vserial.h
 *
 ************************************************************/

#ifndef _VSERIAL_H_
#define _VSERIAL_H_

struct IODevices;

typedef struct SerialDevice SerialDevice;
typedef struct SerialPort SerialPort;

struct SerialDevice {
   void         (*connect)(SerialDevice *sd, SerialPort *sp);
   void         (*transmitByte)(SerialDevice *sd, uint8 byte);
   uint8        (*receiveByte)(SerialDevice *sd);
   int           RxAvail;
};

struct SerialPort {
   struct IODevices *iod;
   SerialDevice *sd;
   
   uint16       baseAddr;
   uint8        IRQ;

   /* transmit receive buffers */
   uint8        IER;
   uint8        IIR;
   uint8        LCR;
   uint8        MCR;
   uint8        LSR;
   uint8        MSR;
   uint8        SCR;
   uint16       DL;
};

void VSerial_Init(SerialPort *sp, struct IODevices *iod, uint16 addr, uint8 IRQ);
void VSerial_SetIOAddr(SerialPort *sp, uint16 addr);
void VSerial_SetIRQ(SerialPort *sp, uint8 IRQ);
void VSerial_Connect(SerialPort *sp, SerialDevice *sd);
void VSerial_ReceiveByte(SerialPort *sp, uint8 byte);
void VSerial_BytesWaiting(SerialPort *sp);
                         
#endif
