/*
 * Copyright (C) 1997 by the Board of Trustees
 *    of Leland Stanford Junior University.
 * 
 * This file is part of the SimOS distribution. 
 * See LICENSE file for terms of the license. 
 *
 */

/****************************************************************
 * embra_globals.c
 *
 * This file contains globals for embra; they are parametrized
 * so that we can have multiple threads of control.
 * 
 * $Author: verghese $
 * $Date: 1999/09/27 22:08:01 $
 *****************************************************************/

#include "parallel.h"
#include "embra_globals.h"

/* Per-thread globals */
struct EmbraGlobal EmbraGlobals[MAX_EMBRA_THREADS];


/* Per-emulated CPU state */
EmbraState* EMP;

/* This is necessary to allow the cp0 module to fool the rest of us */
/* into thinking that ASID 0 never runs */
/* It is set in cp0.c */
int quick_ASID[SIM_MAXCPUS];

/* Real, shared globals */
EmbraParams embra;		/* Simulation parameters */

struct timeval run_start;	/* Time when we enter TC (driver.c) */
struct timeval run_end;		/* Time when we exit TC (simos_interface.c */

int callout_interval = 0;

