/*
 * Copyright (C) 1996-1998 by the Board of Trustees
 *    of Leland Stanford Junior University.
 * 
 * This file is part of the SimOS distribution. 
 * See LICENSE file for terms of the license. 
 *
 */


	/*
	 *  ms_wrklst.h  -  Definitions for the worklist mechanism for
	 *		    the simulator.
	 *
	 *	The worklist mechanism is designed to handle instructions
	 *	take multiple cycles to execute.  These instructions are
	 *	handled by locking their destination register, and then
	 *	scheduling their completion for the appropriate cycle.
	 *
	 *	Most instructions complete in a single cycle, so they
	 *	don't need to use the worklist mechanism.
	 *
	 *	Jim Bennett
	 *	1993, 1994
	 */

#include "simtypes.h"
typedef Reg MXSClientData;

	/* Worklist structure	*/

typedef struct s_wrklst
	{
	int	cycle;			/* Cycle when work is due	*/
	void	(*f)(void *st, MXSClientData a2);
					/* Operation to perform then	*/
	MXSClientData arg2;		/* Argument to function	*/
	struct s_wrklst *next;
	} WorkList;

#define	STX	((struct s_cpu_state *)st)

