/*
 * Copyright (C) 1996-1998 by the Board of Trustees
 *    of Leland Stanford Junior University.
 * 
 * This file is part of the SimOS distribution. 
 * See LICENSE file for terms of the license. 
 *
 */

/*****************************************************************
 * solo_anl.h
 *****************************************************************/

#ifndef SOLO_ANL_H
#define SOLO_ANL_H

#include "solo_interface.h"

#define MSG_SPACE_FLAG	0x80000000 /* from page.h */


/* Calls that are the same for both solo and irix */
extern unsigned long long LoadDouble(void *foo);
extern void StoreDouble(void *foo, unsigned long long ld);

extern void *LockInit(void);
extern void LockEnter(void);
extern int  Lock(void *lock);
extern void Unlock(void *lock);

extern void Sync(void);
extern void Prefetch(void *);
extern void PrefetchX(void *arg);
extern void BarEnter(void);
extern void BarExit(void);

extern void *_Lock_End;
extern void *_Unlock_End;
extern void *_Barrier_End_1;
extern void *_Barrier_End_2;

extern void BDoorStart(void);
extern void BDoorEnd(void);
extern void SoloExit(void);

extern void SoloSetupCommArea(void);        




#endif /* SOLO_ANL_H */











